/*
** This Turbo C program uses the BIT
** function defined in BIT.ASM
**
** Compile with:
**
**   WASM bit bit.obj
**   TCC btest bit.obj
**
** Note: This C program should be
** compiled using a far code model
** (medium, large, or huge).
*/

#include <stdio.h>

/* define external function */

#ifdef __cplusplus
extern "C" { long pascal BIT (int b); }         /* this is Turbo C++ def */
#else
long pascal BIT (int b);                        /* this is Turbo C def */
#endif

int main ()
{
  int i;

  for (i = 1; i <= 32; i++)             /* for each bit */
    printf ("%lX\n", BIT (i));          /* display results */

  return 0;
}
