/*
** This Turbo C program uses the Load and
** Store routines defined in STORE.ASM
**
** Compile with:
**
**   WASM store store.obj
**   TCC stest store.obj
**
** Note: This C program should be
** compiled using a far code model
** (medium, large, or huge).
*/

#include <stdlib.h>
#include <stdio.h>

/* define external functions */

#ifdef __cplusplus
extern "C" {
void pascal Store (int v);
int pascal Load (void);
}
#else
void pascal Store (int v);
int pascal Load (void);
#endif

/* test program */

int main()
{
  int i;

  i = random (32001);
  printf ("The number stored is %i\n", i);
  Store (i);
  printf ("The number retrieved is %i\n", Load());
  return 0;
}
